> For the complete documentation index, see [llms.txt](https://docs.finpay.id/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.finpay.id/finpay-money/linkage/transaction-history/history-list.md).

# History List

This is one of the services providing user e-money transaction history in list format, where partners are able to query the date range for transaction history information. Response may vary depending on the transaction history owned by the user, where partners need to maintain its UI and UX in paginating.

### Technical Specification <a href="#technical-specification" id="technical-specification"></a>

```
Service Code: 12
```

| Environment | Method | URL                                                           |
| ----------- | ------ | ------------------------------------------------------------- |
| Development | POST   | <https://snapstag.finnet.co.id/v1.0/transaction-history-list> |
| Production  | POST   | <https://snap.finnet.co.id/v1.0/transaction-history-list>     |

### Body Request <a href="#body-request" id="body-request"></a>

| No | Name         | Type    | Mandatory | Min Length | Max Length | Description                                                            |
| -- | ------------ | ------- | --------- | ---------- | ---------- | ---------------------------------------------------------------------- |
| 1  | fromDateTime | String  | M         | 1          | 25         | Starting time range. Default: NOW (DESC) or NOW - 3 months (ASC)       |
| 2  | toDateTime   | String  | M         | 1          | 25         | Ending time range. Default: NOW - 3 months (DESC) or NOW (ASC)         |
| 3  | pageSize     | Integer | M         | 1          | 2          | Maximum number of transactions returned in one pagination. Default: 10 |
| 4  | pageNumber   | Integer | M         | 1          | 2          | Current page number. Default: 0                                        |
| 5  | type         | String  | O         | 1          | 6          | Transaction type. Fill with `TRX` or `Top up`                          |
| 6  | sort         | String  | 0         | 1          | 3          | Sorting type by datetime. Fill with `ASC` or `DESC`                    |

#### Sample Request <a href="#sample-request" id="sample-request"></a>

```
{
  "fromDateTime": "2019-07-03T12:08:56+07:00",
  "toDateTime": "2019-07-03T12:08:56+07:00",
  "pageSize": 10,
  "pageNumber": 2,
  "sort":"ASC",
  "type":"TRX"
}
```

### Body Response <a href="#body-response" id="body-response"></a>

| No | Name            | Type                                                 | Mandatory | Min Length | Max Length | Description               |
| -- | --------------- | ---------------------------------------------------- | --------- | ---------- | ---------- | ------------------------- |
| 1  | responseCode    | [Enum](/appendix/enumeration/response-code-list.md)  | M         | 1          | 7          | BI SNAP Response Code.    |
| 2  | responseMessage | String                                               | M         | 1          | 150        | BI SNAP Response Message. |
| 3  | detailData      | [Object](/appendix/json-object/detaildata-object.md) | O         | 1          | 7          | Datail Data               |

#### Sample Response <a href="#sample-response" id="sample-response"></a>

```
{
  "responseCode": "2001200",
  "responseMessage": "Request has been processed successfully",
  "detailData": [
    {
      "dateTime": "2022-12-02T08:18:13+00:00",
      "amount": {
        "value": "10000.00",
        "currency": "IDR"
      },
    "remark": "Pulsa Rp. 10000",
    "status": "SUCCESS",
    "type": "TEST",
    "additionalInfo": {
        "partnerReferenceNo": "78912343452347003",
        "referenceNo": "2212020005597959",
        "trxcode": "WS_TRX_TRANSFER",
        "id": "16109172",
        "sum_in": "0",
        "sum_out": "10000",
        "channel_id": "140",
        "source": "+6281977817902",
        "destination": "+628198765432112",
        "name": "Testing"
      }
    },
    {
    "dateTime": "2022-12-02T13:15:18+00:00",
    "amount": {
        "value": "1000.00",
        "currency": "IDR"
      },
    "remark": "pulsa 1000",
    "status": "SUCCESS",
    "type": "TEST",
    "additionalInfo": {
        "partnerReferenceNo": "7891234345230001",
        "referenceNo": "2212020005599921",
        "trxcode": "WS_TRX_TRANSFER",
        "id": "16109272",
        "sum_in": "0",
        "sum_out": "1000",
        "channel_id": "140",
        "source": "+6281977817902",
        "destination": "+628198765432112",
        "name": "Testing"
      }
    }
  ]
}
```

### Response Code & Message <a href="#response-code--message" id="response-code--message"></a>

The table below lists response codes and messages for the History List API.

| No | HTTP Code | Code    | Message (Indonesian)            |
| -- | --------- | ------- | ------------------------------- |
| 1  | 200       | 2001200 | Successful                      |
| 2  | 400       | 4001200 | Bad request                     |
| 3  | 400       | 4001201 | Invalid field format {field}    |
| 4  | 400       | 4001202 | Invalid mandatory field {field} |
| 5  | 401       | 4011201 | Invalid token (B2B)             |
| 6  | 401       | 4011200 | Unauthorised. \[Reason]         |
| 7  | 403       | 4031201 | Feature not allowed             |
| 8  | 403       | 4031204 | Activity count limit exceeded   |
| 9  | 404       | 4041208 | Invalid merchant                |
| 10 | 500       | 5001200 | General error                   |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.finpay.id/finpay-money/linkage/transaction-history/history-list.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
